#ifndef __CURSOR_C__
#define __CURSOR_C__

#include "Cursor.h"

PCURSOR Cursor_ctor(PCURSOR pCursor,int x,int y,int w,int h,bool hwrap,bool vwrap)
{
	Cursor_set_w(pCursor,w);
	Cursor_set_h(pCursor,h);
	Cursor_set_x(pCursor,x);
	Cursor_set_y(pCursor,y);
	Cursor_set_hwrap(pCursor,hwrap);
	Cursor_set_vwrap(pCursor,vwrap);
	return(pCursor);
}

PCURSOR Cursor_new(int x,int y,int w,int h,bool hwrap,bool vwrap)
{
	PCURSOR pCursor;
	pCursor=NEW(CURSOR);
	Cursor_ctor(pCursor,x,y,w,h,hwrap,vwrap);
	return(pCursor);
}

void Cursor_dtor(PCURSOR pCursor,int memflag)
{
	if(memflag==FREE_MEMORY)
	{
		free(pCursor);
	}
}

void Cursor_del(PCURSOR pCursor)
{
	Cursor_dtor(pCursor,FREE_MEMORY);
}

void Cursor_set_x(PCURSOR pCursor,int x)
{
	if(Cursor_get_hwrap(pCursor))
	{
		x%=pCursor->m_w;
		if(x<0) x+=pCursor->m_w;
	}
	else
	{
		if(x<0) x=0;
		if(x>=Cursor_get_w(pCursor)) x=Cursor_get_w(pCursor)-1;
	}
	pCursor->m_x=x;
}

void Cursor_set_y(PCURSOR pCursor,int y)
{
	if(Cursor_get_vwrap(pCursor))
	{
		y%=pCursor->m_h;
		if(y<0) y+=pCursor->m_h;
	}
	else
	{
		if(y<0) y=0;
		if(y>=Cursor_get_h(pCursor)) y=Cursor_get_h(pCursor)-1;
	}
	pCursor->m_y=y;
}

int Cursor_get_x(PCURSOR pCursor)
{
	return(pCursor->m_x);
}

int Cursor_get_y(PCURSOR pCursor)
{
	return(pCursor->m_y);
}

void Cursor_move(PCURSOR pCursor,int x,int y)
{
	Cursor_set_x(pCursor,x);
	Cursor_set_y(pCursor,y);
}

void Cursor_move_rel(PCURSOR pCursor,int dx,int dy)
{
	Cursor_move(pCursor,Cursor_get_x(pCursor)+dx,Cursor_get_y(pCursor)+dy);
}

void Cursor_set_w(PCURSOR pCursor,int w)
{
	if(w<1) w=1;
	pCursor->m_w=w;
	Cursor_set_x(pCursor,Cursor_get_x(pCursor));
}

void Cursor_set_h(PCURSOR pCursor,int h)
{
	if(h<1) h=1;
	pCursor->m_h=h;
	Cursor_set_y(pCursor,Cursor_get_y(pCursor));
}

int Cursor_get_w(PCURSOR pCursor)
{
	return(pCursor->m_w);
}

int Cursor_get_h(PCURSOR pCursor)
{
	return(pCursor->m_h);
}

void Cursor_set_hwrap(PCURSOR pCursor,bool hwrap)
{
	pCursor->m_hwrap=hwrap;
}

void Cursor_set_vwrap(PCURSOR pCursor,bool vwrap)
{
	pCursor->m_vwrap=vwrap;
}

bool Cursor_get_hwrap(PCURSOR pCursor)
{
	return(pCursor->m_hwrap);
}

bool Cursor_get_vwrap(PCURSOR pCursor)
{
	return(pCursor->m_vwrap);
}

#endif