#ifndef __CURSOR_H__
#define __CURSOR_H__

#include "cywin.h"

#define NEW(x) (x*)malloc(sizeof(x))

typedef struct _Cursor
{
	int m_x;
	int m_y;
	int m_w;
	int m_h;
	bool m_hwrap;
	bool m_vwrap;
} Cursor;

typedef struct _Cursor CURSOR;
typedef struct _Cursor* PCURSOR;

PCURSOR Cursor_ctor(PCURSOR pCursor,int x,int y,int w,int h,bool hwrap,bool vwrap);
PCURSOR Cursor_new(int x,int y,int w,int h,bool hwrap,bool vwrap);

void Cursor_dtor(PCURSOR pCursor,int memflag);
void Cursor_del(PCURSOR pCursor);

void Cursor_set_x(PCURSOR pCursor,int x);
void Cursor_set_y(PCURSOR pCursor,int y);
void Cursor_set_w(PCURSOR pCursor,int w);
void Cursor_set_h(PCURSOR pCursor,int h);
void Cursor_set_hwrap(PCURSOR pCursor,bool hwrap);
void Cursor_set_vwrap(PCURSOR pCursor,bool vwrap);

int Cursor_get_x(PCURSOR pCursor);
int Cursor_get_y(PCURSOR pCursor);
int Cursor_get_w(PCURSOR pCursor);
int Cursor_get_h(PCURSOR pCursor);
bool Cursor_get_hwrap(PCURSOR pCursor);
bool Cursor_get_vwrap(PCURSOR pCursor);

void Cursor_move(PCURSOR pCursor,int x,int y);
void Cursor_move_rel(PCURSOR pCursor,int dx,int dy);

#endif
