#ifndef __MAP_C__
#define __MAP_C__

#include "Map.h"

PMAP Map_ctor(PMAP pMap,int width,int height)
{
	if(width<1) width=1;
	if(height<1) height=1;
	pMap->m_w=width;
	pMap->m_h=height;
	pMap->m_map=(char*)malloc((int)Map_get_size(pMap));
	Map_clear(pMap,0);
	return(pMap);
}

PMAP Map_ctor_Ex(PMAP pMap,struct FileInput* pInput)
{
	int w;
	int h;
	w=FileInput_read_byte(pInput);
	h=FileInput_read_byte(pInput);
	Map_ctor(pMap,w,h);
	FileInput_read(pInput,pMap->m_map,Map_get_size(pMap));	
	return(pMap);
}

PMAP Map_new(int width,int height)
{
	PMAP pMap;
	pMap=NEW(MAP);
	Map_ctor(pMap,width,height);
	return(pMap);
}

PMAP Map_new_Ex(struct Input* pInput)
{
	PMAP pMap;
	pMap=NEW(MAP);
	Map_ctor_Ex(pMap,pInput);
	return(pMap);
}

void Map_dtor(PMAP pMap,int memflag)
{
	free(pMap->m_map);
	if(memflag==FREE_MEMORY);
	{
		free(pMap);
	}
}

void Map_del(PMAP pMap)
{
	Map_dtor(pMap,FREE_MEMORY);
}

void Map_set_square(PMAP pMap,int x,int y,char val)
{
	int index;
	if(x<0) return;
	if(y<0) return;
	if(x>=Map_get_w(pMap)) return;
	if(y>=Map_get_h(pMap)) return;
	index=x+y*Map_get_w(pMap);
	pMap->m_map[index]=val;
}

char Map_get_square(PMAP pMap,int x,int y)
{
	int index;
	if(x<0) return(0);
	if(y<0) return(0);
	if(x>=Map_get_w(pMap)) return(0);
	if(y>=Map_get_h(pMap)) return(0);
	index=x+y*Map_get_w(pMap);
	return(pMap->m_map[index]);
}

int Map_get_w(PMAP pMap)
{
	return(pMap->m_w);
}

int Map_get_h(PMAP pMap)
{
	return(pMap->m_h);
}

void Map_clear(PMAP pMap,char val)
{
	int x;
	int y;
	for(x=0;x<Map_get_w(pMap);x++)
	{
		for(y=0;y<Map_get_h(pMap);y++)
		{
			Map_set_square(pMap,x,y,val);
		}
	}
}

void Map_write(PMAP pMap,struct Output* pOutput)
{
	Output_write_byte(pOutput,Map_get_w(pMap));
	Output_write_byte(pOutput,Map_get_h(pMap));
	Output_write(pOutput,pMap->m_map,Map_get_size(pMap));
}

long Map_get_size(PMAP pMap)
{
	return(Map_get_w(pMap)*Map_get_h(pMap)*sizeof(char));
}

#endif