#ifndef __VIEW_C__
#define __VIEW_C__

#include "View.h"

PVIEW View_ctor(PVIEW pView,struct Graphics* pTarget,int x,int y,int width,int height,drawmode_t dm,color_t col,int flips)
{
	struct Bitmap* pBitmap;
	pBitmap=NEW(struct Bitmap);
	Bitmap_ctor_Ex2(pBitmap,width,height,2);
	Graphics_ctor_Ex(pView,pBitmap);
	View_set_x(pView,x);
	View_set_y(pView,y);
	View_set_target(pView,pTarget);
	View_set_target_draw_mode(pView,dm);
	View_set_target_bkcolor(pView,col);
	View_set_flips(pView,flips);
	return(pView);
}

PVIEW View_new(struct Graphics* pTarget,int x,int y,int width,int height,drawmode_t dm,color_t col,int flips)
{
	PVIEW pView;
	pView=NEW(VIEW);
	View_ctor(pView,pTarget,x,y,width,height,dm,col,flips);
	return(pView);
}

void View_dtor(PVIEW pView,int memflag)
{
	struct Bitmap* pBitmap;
	pBitmap=View_get_bitmap(pView);
	Bitmap_dtor(pBitmap,FREE_MEMORY);
	View_set_bitmap(pView,0);
	if(memflag==FREE_MEMORY)
	{
		free(pView);
	}
}

void View_del(PVIEW pView)
{
	View_dtor(pView,FREE_MEMORY);
}

void View_set_x(PVIEW pView,int x)
{
	pView->m_xdst=x;
}

void View_set_y(PVIEW pView,int y)
{
	pView->m_ydst=y;
}

void View_set_target(PVIEW pView,struct Graphics* pTarget)
{
	pView->m_target=pTarget;
}

void View_set_target_draw_mode(PVIEW pView,drawmode_t dm)
{
	pView->m_targetdm=dm;
}

void View_set_target_bkcolor(PVIEW pView,color_t col)
{
	pView->m_targetbc=col;
}

void View_set_flips(PVIEW pView,int flips)
{
	pView->m_flips=flips;
}

int View_get_x(PVIEW pView)
{
	return(pView->m_xdst);
}

int View_get_y(PVIEW pView)
{
	return(pView->m_ydst);
}

struct Graphics* View_get_target(PVIEW pView)
{
	return(pView->m_target);
}

drawmode_t View_get_target_draw_mode(PVIEW pView)
{
	return(pView->m_targetdm);
}

color_t View_get_target_bkcolor(PVIEW pView)
{
	return(pView->m_targetbc);
}

int View_get_flips(PVIEW pView)
{
	return(pView->m_flips);
}

void View_show(PVIEW pView)
{
	Graphics_set_draw_mode(View_get_target(pView),View_get_target_draw_mode(pView));
	Graphics_set_bkcolor(View_get_target(pView),View_get_target_bkcolor(pView));
	Graphics_draw_bitmap(View_get_target(pView),View_get_bitmap(pView),View_get_x(pView),View_get_y(pView),View_get_flips(pView));
}

#endif