#ifndef __VIEW_H__
#define __VIEW_H__

#include "cywin.h"

#define NEW(x) (x*)malloc(sizeof(x))

typedef struct _View: public Graphics
{
	struct Graphics* m_target;
	int m_xdst;
	int m_ydst;
	drawmode_t m_targetdm;
	color_t m_targetbc;
	int m_flips;
} View;

typedef struct _View VIEW;
typedef struct _View* PVIEW;

PVIEW View_ctor(PVIEW pView,struct Graphics* pTarget,int x,int y,int width,int height,drawmode_t dm,color_t col,int flips);
PVIEW View_new(struct Graphics* pTarget,int x,int y,int width,int height,drawmode_t dm,color_t col,int flips);

void View_dtor(PVIEW pView,int memflag);
void View_del(PVIEW pView);

void View_set_x(PVIEW pView,int x);
void View_set_y(PVIEW pView,int y);
void View_set_target(PVIEW pView,struct Graphics* pTarget);
void View_set_target_draw_mode(PVIEW pView,drawmode_t dm);
void View_set_target_bkcolor(PVIEW pView,color_t col);
void View_set_flips(PVIEW pView,int flips);

int View_get_x(PVIEW pView); 
int View_get_y(PVIEW pView); 
struct Graphics* View_get_target(PVIEW pView);
drawmode_t View_get_target_draw_mode(PVIEW pView);
color_t View_get_target_bkcolor(PVIEW pView);
int View_get_flips(PVIEW pView);

void View_show(PVIEW pView);

#define View_draw_bitmap Graphics_draw_bitmap 
#define View_draw_char Graphics_draw_char
#define View_draw_text Graphics_draw_text
#define View_draw_text_Ex Graphics_draw_text_Ex
#define View_get_bitmap Graphics_get_bitmap
#define View_get_char_height Graphics_get_char_height
#define View_get_char_width Graphics_get_char_width
#define View_get_font Graphics_get_font
#define View_string_width Graphics_string_width
#define View_string_width_Ex Graphics_string_width_Ex
#define View_set_bitmap Graphics_set_bitmap
#define View_set_font Graphics_set_font
#define View_scroll Graphics_scroll
#define View_draw_hline Graphics_draw_hline
#define View_draw_vline Graphics_draw_vline
#define View_draw_line Graphics_draw_line
#define View_draw_rect Graphics_draw_rect
#define View_draw_rect_Ex Graphics_draw_rect_Ex
#define View_fill_rect Graphics_fill_rect
#define View_fill_rect_Ex Graphics_fill_rect_Ex
#define View_fill_screen Graphics_fill_screen
#define View_get_bytes_total Graphics_get_bytes_total
#define View_set_clip Graphics_set_clip
#define View_get_clip Graphics_get_clip
#define View_set_clip_Ex Graphics_set_clip_Ex
#define View_get_color Graphics_get_color
#define View_set_color Graphics_set_color
#define View_get_draw_mode Graphics_get_draw_mode
#define View_set_draw_mode Graphics_set_draw_mode
#define View_put_background Graphics_put_background
#define View_get_pixel Graphics_get_pixel
#define View_set_pixel Graphics_set_pixel
#define View_get_buf_addr Graphics_get_buf_addr
#define View_set_bkcolor Graphics_set_bkcolor

#endif
